﻿// ------------------------------------------------------------------------------------
// speaking time
// a sample by andreas horlacher
// ------------------------------------------------------------------------------------
var speaktext=new Array();
var theTimeString="";
var oFlash=null;
var i=0;
var start, end=0;
var tempVal="";
var objVoice = new ActiveXObject("Sapi.SpVoice"); 
var memo="";




// ------------------------------------------------------------------------------------
function view_onOpen() {
	memo=options.getValue("memo");
	create_memo();
	if (memo=="" ) { memo=MEMO_TEXT };
	init_text();
	setTimeout(function(){setInterval(gdgtController, 1000)},1000);
}

// ------------------------------------------------------------------------------------
function gdgtController() {
	setTimeStamp();

	// rotation
	var i=toInt(imgMinutes.rotation);
	i+=10;
	if (i>360 ) { i=0 };
	// beginAnimation(function(){imgMinutes.rotation=event.value}, imgMinutes.rotation, i, 500);
	beginAnimation(function(){imgMinutes.rotation=event.value}, 1, 359, 500);
	debug.trace("r="+imgMinutes.rotation);

	oFlash=gdFlash.object;
	view.caption=theTimeString;

	try { oFlash = gdFlash.object }catch(ex) { debug.trace("catch 1") };
	try{ 
		oFlash.setVariable("timestr", theTimeString); 
		++i;
		if(i==10){ 
			oFlash.setVariable("actionstr", "action"); i=0; 
		} else { 
			if (Math.random()*2 > 1 ){
				oFlash.setVariable("actionstr", "nothing")}
				};
	}catch(ex) { debug.trace("catch 2")};
	try{ debug.trace(oFlash.getVariable("timestr"))}catch(ex) { debug.trace("catch 3")};
}



function init_text() {
	for (var i=1;i<=24;++i) {
		tempVal=options.getValue(i);
		if(tempVal==""){
			tempVal=eval("T"+i);
	debug.trace(tempVal);
			options.putValue(i,tempVal);
			};
		speaktext[i]=tempVal;
		};
}


// ------------------------------------------------------------------------------------
// memo field
function create_memo() {
	var mh=view.height-36;
	var mw=view.width-40;
	var strXML="<edit name=\"edMemo\" font=\"Verdana\" size=\"8\" wordwrap=\"true\" multiline=\"true\" width=\""+mw+"\" height=\""+mh+"\" x=\"25\" y=\"17\" visible=\"false\" />";
	view.appendElement(strXML);
}

function show_memo() {
	edMemo.value=memo;
	edMemo.visible=true;
}

function hide_memo() {
	options.putValue("memo", edMemo.value);
	memo=edMemo.value;
	edMemo.visible=false;
}
// ------------------------------------------------------------------------------------



// ------------------------------------------------------------------------------------
// speak string
function speak(str){
	objVoice.Speak( str, 1);
	debug.trace("saying "+str);
}
// ------------------------------------------------------------------------------------

function toInt ( x ) { return ( x > 0 ? Math.floor( x ) : Math.ceil ( x ) ) } // Returns an integer 


function setup(){
	pluginHelper.showOptionsDialog();
}




function info_click() {
	var oldcw=container.width;
	var oldcx=container.x;

	beginAnimation(shrink, 1,100, 1500 );
	setTimeout(start_expand, 5*1000);
	setup();

	function shrink() {
		container.width=(100-event.value)+"%";
		container.x=(event.value/1)+"%";
		container.rotation=event.value;
	}

	function start_expand() {
		beginAnimation( expand, 1,100,1500);

	}

	function expand() {
		container.width=event.value+"%";
		container.x=(100-event.value/1)+"%";
		container.rotation=(100-event.value);
		if (event.value>99 ) {container.x=oldcx; container.width=oldcw; };
	}
}


function show_infobutton() {
	imgInfoButton.visible=true;
	beginAnimation(function(){imgInfoButton.opacity=event.value},1,255,500);
	setTimeout(show_memo(),13000);

}

function hide_infobutton() {
	imgInfoButton.visible=false;
	hide_memo();
}


function place_minutes(min) {
	var diff=12; // border
	var posX, posY=0;
	var h=toInt((view.height-2*diff)/2);
	var w=toInt((view.width-2*diff)/2);


	if ( min <=8 ) { posX=w+toInt(view.width/8*min); posY =diff; };
	if ( min > 8 && min <=15 ) { posY=diff+h-toInt(h/8*(min-8)); posX = view.width-diff; };
	if ( min > 15 && min <=23 ) { posY=diff+h+toInt(h/8*(min-15)); posX = view.width-diff; };
	if ( min > 23 && min <=30 ) { posY=view.height-diff; posX=view.width-diff-toInt(w/8*(min-23)) };
	if ( min > 30 && min <=38 ) { posY=view.height-diff; posX=diff+w-toInt(w/8*(min-30)) };
	if ( min > 38 && min <=45 ) { posX=diff; posY=h*2-toInt(h/8*(min-38)) };
	if ( min > 45 && min <=52 ) { posX=diff; posY=h-toInt(h/8*(min-45)) };
	if ( min > 52 && min <=59 ) { posY=diff; posX=w-toInt(h/8*(min-52)) };
	if ( min==0 ) { posX=toInt(view.width/2); posY = diff; };

	imgMinutes.x=posX;
	imgMinutes.y=posY;

	debug.trace("min x="+posX+"  y="+posY);
}



//***************************************************************
// time stamp
//***************************************************************
function setTimeStamp() {
	var currentTime = new Date();
	var hours = currentTime.getHours();
	var minutes = currentTime.getMinutes();
	var seconds = currentTime.getSeconds();

	var sReturn = "";

	if ( hours < 10 ) { hours = "0" + hours };
	if ( minutes < 10 ) { minutes = "0" + minutes };
	if ( seconds < 10 ) { seconds = "0" + seconds };

	if ( toInt(seconds)==59 && toInt(minutes)==59 ){ // time to say the speaktext 
		speak(speaktext[toInt(hours)+1]);
		};
debug.trace("!!!"+toInt(seconds));
	if (toInt(seconds)==59) {
		try {  tempVal = speaktext[toInt(minutes)+1] } catch(ex) {tempVal="nothing!" };
debug.trace("*3*******");
		// speak(tempVal);
		};

	place_minutes(toInt(minutes));



	theTimeString = hours+":"+minutes+":"+seconds;

}